/* GMS_Poll.thor by Roy Brown (Roy@ebrown.demon.co.uk)
** $VER: GMS_Poll.thor 1.0 (12.11.95)
**
** An ARexx script that automatically runs GMS to poll a BBS selected
** from a requester. The script assumes that you have configured a GMS
** line for each Boss (numbered 1, 2 etc - NOT Line 0 which is the default
** line - see the GMS docs).
**
** This script should be added to your Arexx Script menu.
*/

/* Enter the path to gms_mailer. */

GMS_Path="GMS:Bin/"      /* must end with either ":" or "/" */

/* Modify the next line (no spaces) to show each BBS name that you poll from.
** This is the text that will appear on the buttons in the requester. If you
** want to make the boss you poll most often the default (i.e. press return to
** call), make it the first entry. Use the underscore (to the left of the
** 'equals/plus' key) to indicate the keyboard shortcut.
*/

BUTTEXT="_Amigo|_FrostFree"

/* Enter your total number of bosses */

BOSSES=2

/* Please do not alter anything below here. Thank you.*/

options results

/* Check to see if Thor REXX port available*/

p = ' ' || address() || ' ' || show('P',,)
thorport = pos(' THOR.',p)

if thorport > 0 then thorport = word(substr(p,thorport+1),1)
else
do
	say 'No THOR port found!'
	exit 10
end

/* If more than one Boss configured above, open a requester to select the BBS
** to poll. Otherwise run GMS using line 0 configuration (the default line).
*/

select
     when BOSSES=1 then line=0
     when BOSSES>1 then
       do
          address(thorport)
          THORTOFRONT
          REQUESTNOTIFY TEXT '"Select BBS to poll"' BT ''||BUTTEXT||'|_Cancel'
          line=result
          if line=0 then exit
       end
end

/* Run GMS */

address command "run >nil: "||GMS_Path||"gms_mailer line "||line

exit
..........................................................................................

