/* TrapDoorPoll.thor by Troels Walsted Hansen
** $VER: TrapDoorPoll.thor 1.50 (3.6.95)
**
** An ARexx script that automates TrapDoor polling of a
** BBS selected from a listview. The script assumes that
** you have configured one main TrapDoor.cfg and several
** small cfg files for each of your bosses.
**
** History:
** 
** TrapDoorPoll.thor v1.10 (25.11.94)
**  don't open requester if there's only one boss configured
**
** TrapDoorPoll.thor v1.50 (03.06.95)
**  if NComm is running you will be prompted with the option of quitting it
*/

/* config the below according to your setup */

trapdoorpath = "MAIL:Bin/"	/* must end with either ":" or "/" */

BOSS.1 = "ProSoft Node #1"
CONFIG.1 = "mail:TrapDoor.cfg.prosoft1"

BOSS.2 = "ProSoft Node #2"
CONFIG.2 = "mail:TrapDoor.cfg.prosoft2"

BOSS.3 = "AmigaZone"
CONFIG.3 = "mail:TrapDoor.cfg.amizone"

BOSS.COUNT = 3			/* number of configured bosses */

/* don't touch anything below here */

options results

/* needs THOR and bbsread.library functions */

p = ' ' || address() || ' ' || show('P',,)
thorport = pos(' THOR.',p)

if thorport > 0 then thorport = word(substr(p,thorport+1),1)
else
do
	say 'No THOR port found!'
	exit 10
end

if ~show('p', 'BBSREAD') then
do
	address command
		"run >nil: `GetEnv THOR/THORPath`bin/LoadBBSRead"
		"WaitForPort BBSREAD"
end

/* request BBSes or dial the only one configured */

select
	when(BOSS.COUNT = 1) then result = BOSS.1
	when(BOSS.COUNT > 1) then
	do
		address(thorport)
		THORTOFRONT
		REQUESTLIST instem BOSS title '"Select BBS to poll:"' SIZEGADGET
		if(rc ~= 0) then exit
	end
	otherwise exit
end

do i=1 to BOSS.COUNT
	if(result = BOSS.i) then break
end

/* if NComm is started it'll probably be holding on to the serial port */

if(show('p', 'ncomm')) then
do
	address(thorport)
	REQUESTNOTIFY TEXT '"Do you want to quit NComm?"' BT '"_Yes|No"'
	if(result = 1) then
	do
		address('ncomm')
		QUIT
	end
end

/* start TrapDoor */

address command "run >nil: " || trapdoorpath || "TrapDoor CONFIG " || CONFIG.i
exit
